#define ORG .org
#define EQU .equ
#define DB  .db
#define DW  .dw

#define SD_DBG_PRINT

#define SD_HWM_PVV
#define FAT16_ON
#define RWR

;==========================================================

;#ifdef RK86
GETC  EQU 0F803H
PUTC  EQU 0F809H
PRINT EQU 0F818H
PRHEX EQU 0F815H
IfKeyPress EQU 0F81BH
SD_DATA_PORT EQU 0d000H
SD_CONF_PORT EQU SD_DATA_PORT+1
START_ADDR   EQU 0f000H
BUF     EQU 06800h
;#endif
;==========================================================

BUFDIR  EQU BUF+0200h
CWD     EQU BUF+0400H
FATSEC  EQU BUF+0500H

ROOTSEC EQU FATSEC+4
DATASEC EQU ROOTSEC+4
ROOTLEN EQU DATASEC+4
ROOTLNS EQU ROOTLEN+2
SECINBL EQU ROOTLNS+2
FAT_NXT EQU SECINBL+1
BUFSEC  EQU FAT_NXT+3
BLKLEN  EQU BUFSEC+4
BLKSEC  EQU BLKLEN+1
BNEXT   EQU BLKSEC+4
FBPOS   EQU BNEXT+4
FBLEN   EQU FBPOS+2
DIRREC  EQU FBLEN+2
CWDBLK  EQU DIRREC+1
LINEBUF EQU CWDBLK+4
SDTYPE  EQU LINEBUF+38h

  ORG START_ADDR
; 0xCB7F  => BC=crc

;CALL FS_FNDF ; DE - name of file for finding, out HL - string FAT record of file
;CALL F_OPEN ; DE - name of file for opening, out C==1 if file not founded
;CALL F_READ ; HL - addr for store readed data, BC - size of readed data
;#ifdef GAL
;  ORG START_ADDR-10
;  DB 0,0,0,0,0
;  DB 0A5h
;  DB 00,70h,0ffh,7fh
;#endif


ENTRY:
;=============================================
;#ifdef SD_DBG_PRINT
  LXI H,TSD_INIT
  CALL PRINT
  jmp DBG_SDINIT
TSD_INIT: DB "SDOS-8086_V8.6",0DH,0ah,0
DBG_SDINIT:
;#endif
;=============================================
  lxi h,BUF
  lxi b,2048-256
clrmem:
  mvi m,0
  inx h
  dcx b
  mov a,c
  ora b
  jnz clrmem
  CALL FS_RST
LOOP:    MVI C,38H
  LXI H,LINEBUF
LOOP0:
  mvi m,0
  inx h
  DCR C
  JNZ LOOP0
  LXI H,A_DRIVE
  CALL PRINT
  LXI H,CWD
  CALL PRINT
  MVI C,'>'
  CALL PUTC
  CALL READLN
  LXI H,LOOP
  PUSH H
  LXI H,CMDLST
LOOP1:  MOV A,M
  ORA A
  JZ RUNFILE
  LXI D,LINEBUF
LOOP2:  MOV A,M
  ORA A
  JZ LOOP3
  LDAX D
  CMP M
  JNZ LOOP4
  INX D
  INX H
  JMP LOOP2
LOOP3:  LDAX D
  ORA A
  JZ LOOP5
  CPI 20H
  JZ LOOP5
LOOP4:  MOV A,M
  INX H
  ORA A
  JNZ LOOP4
  INX H
  INX H
  JMP LOOP1
LOOP5:  INX H
  MOV E,M
  INX H
  MOV D,M
  CALL PRINT_NEWLINE
  XCHG
  PCHL

PRINTN: MOV C,M
  INX H
  CALL PUTC
  DCR B
  JNZ PRINTN
  RET

C_DIR:
  LXI D,LINEBUF+2
  INX D
  LDAX D
  CPI 20H
  JZ $-4
  ORA A
  JNZ $+6
  LXI D,ALLFILS
  CALL FS_FNDF
  JC C_DIRNO 
C_DIR1: PUSH H
  CALL IfKeyPress ; ii?in ia?aoey eiiiie 
  CPI 0FFH    ; i?einoaiiaea auaiaa nienea oaeeia anee anou ia?aoea e?aie eiiiee
  JNZ $-5
  LXI B,11
  DAD B
  MOV A,M
  POP H
  ANI 8
  JNZ C_DIR2
  MVI B,8
  CALL PRINTN
  MVI C,' '
  CALL PUTC
  MVI B,3
  CALL PRINTN
  MVI C,' '
  CALL PUTC
  mov A,M
  ani 010H
  jz C_DIR11
  LXI H,NODIR+4 ;_DIR   CALL PRINT
  jmp C_DIR12
C_DIR11:
  mov A,L
  adi 012H
  mov L,A
  mov A,M
  call PRHEX
  dcx H
  mov A,M
  call PRHEX
C_DIR12:
  CALL PRINT_NEWLINE
C_DIR2: CALL FS_FNDN
  JNC C_DIR1
  RET
C_DIRNO_POPH:
  pop H
C_DIRNO:LXI H,NOFILES
  JMP PRINT
 C_CD: LXI H,LINEBUF+1
  INX H
  MOV A,M
  CPI 20H
  JZ $-4
  ORA A
  JNZ C_CD1
  CALL PRINT_NEWLINE
  LXI H,CWD
  JMP PRINT
C_CD1:  XCHG
  CALL FS_CHDIR
  RNC
  LXI H,NODIR
  JMP PRINT
 C_I: 
  CALL SD_OFF
  pop H
  JMP START_ADDR

C_X: 
  CALL SD_OFF
  JMP 0F800H

;#ifdef RWR ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
C_RWR: 
  LXI D,LINEBUF+2
  CALL F_OPEN
  JC C_DIRNO ; no file
  LXI H,LINEBUF+2
C_RWR1: 
  MOV A,M
  CPI 0
  JZ C_RWR2
  CPI 2CH
  INX H
  JNZ C_RWR1
C_RWR2: 
  CALL R65
  LXI H,ERR
  JC PRINT
  LHLD LINEBUF+26  ;size iaeanoe
  MOV  C,L  ;
  MOV  B,H  ;
  LHLD LINEBUF+24  ;AA?AN  ia?aea iaeanoe
  LXI D,LINEBUF
  LDAX D
  CPI 'R'
  JZ C_RWR3
  CALL F_WRITE
  JMP C_RWR4
C_RWR3: 
  CALL F_READ
C_RWR4: 
;#endif ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
  LXI H,RWR_OK
  JMP PRINT

;**********************************************
RUNFILE: ;RK-86
  CALL PRINT_NEWLINE
  LXI H,LINEBUF
  MVI C,'.'
  CALL STRCHR
  JNC RUNF1
  LXI D,DOTRK
  CALL STRCPY
RUNF1:  LXI D,LINEBUF
  CALL F_OPEN
  JC C_DIRNO ; no file
RD_4B:
  LXI B,4 ; ?eoaai ec RK? oaeea aa?an noa?oa i?ia?aiiu/eoaa neeaauaaou a iaiyoe e eiiao ai eioi?iai neeaauaaai aaiiua a iaiyoe
  LXI H,LINEBUF
  push H
  CALL F_READ
  pop H
  MOV D,M
  INX H
  MOV E,M
  INX H
  MOV B,M
  INX H
  MOV A,M
  SUB E
  MOV C,A
  MOV A,B
  SBB D
  MOV B,A
  INX B  ;?acia? oaeea
  XCHG
  PUSH H ;nio?aiyai aa?an noa?oa, a ret iinea F_READ naaeaao ia?aoia ia yoio aa?an
  push B
  push B
  mov A,H
  call PRHEX
  mov A,L
  call PRHEX
  MVI C,','
  CALL PUTC
  mov A,B
  call PRHEX
  POP B
  mov A,C
  call PRHEX
  POP B
  CALL F_READ
  jmp SD_OFF

READLN: LXI H,LINEBUF
READL1:
 CALL GETC
  CPI 8
  JZ READL3
  CPI 5FH
  JZ READL3
  CPI 18H
  JZ READL4
  MVI M,0
  CPI 0DH
  RZ
  MOV M,A
  INX H
READL2: MOV C,A
  CALL PUTC
  JMP READL1
READL3: MOV A,L
  CPI LINEBUF & 255
  JZ READL1
  MVI C,8
  CALL PUTC
  MVI C,20H
  CALL PUTC
  MVI C,8
  CALL PUTC
  DCX H
  JMP READL1
READL4: MOV A,M
  ORA A
  JZ READL1
  CPI 0DH
  JZ READL1
  INX H
  JMP READL2
;**********************************************
;#ifdef RWR ;!!!!!!!!!!!!!!!!!!!!!!!!!!!

SET_LAST_SPACE:
  INX D
  push D
  mvi c,0AH R66:
  LDAX D
  CPI 0
  JNZ R68
  MVI A,20H
  STAX D
  JMP R67
R68:
  INX D
  DCR C
  JNZ R66
R67:
  pop D
  ret
;**********************************************
;Iiai?ia?aiia aaiaa aa?ania aey ooieoee
;**********************************************
R65:
  XCHG
  LXI  H,0
  shld LINEBUF+24
  shld LINEBUF+26
  CALL R7C 
  shld LINEBUF+24
  RC
  CALL R7C 
  shld LINEBUF+26
;  RC
  ret
;*********************************************
;Iiai?ia?aiia aaiaa iaiiai 16 aa?ana
;*********************************************
R7C:  
      LXI  H,0 
      MVI  B,0
R7F:  
      LDAX D
      INX  D
      CPI  00H
      JZ   R7E 
      CPI  2CH
      RZ
      CPI  20H
      JZ   R7F 
      SUI  30H
      JM   R79 
      CPI  0AH
      JM   R80 
      CPI  11H
      JM   R79 
      CPI  17H
      JP   R79 
      SUI  07H
R80:
      MOV  C,A
      DAD  H
      DAD  H
      DAD  H
      DAD  H
      JC   R79 
      DAD  B
      JMP  R7F 
R79:
  STC
R7E:
      RET
;#endif ;!!!!!!!!!!!!!!!!!!!!!!!!!!!

;*********************************************
PRINT_NEWLINE:
  LXI H,NEWLINE
  CALL PRINT
  RET 
NEWLINE:DB 0DH,0AH,0
A_DRIVE:DB 0DH,0AH,"A:",0
NOFILES:DB "NO FILE(S)",0

RWR_OK: DB "OK",0DH,0
ERR:    DB "ERR",0DH,0
ALLFILS:DB "*",0

DOTRK:  DB ".RKR",0
 NODIR:  DB 0DH,"NO "  CMDLST: DB "DIR",0         DW C_DIR
        DB "CD",0
        DW C_CD
        DB "X",0
        DW C_X
;#ifdef RWR ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
        DB "R",0
        DW C_RWR
        DB "W",0
        DW C_RWR
;#endif ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
        DB "I",0
        DW C_I
        DB 0

;http://elm-chan.org/docs/mmc/ima/sdinit.png
; command response R1
; 0x00 ok
; or bitfield
; 0x01 idle state
; 0x02 erase reset
; 0x04 illegal command
; 0x08 command crc error
; 0x10 erase sequence error
; 0x20 address error
; 0x40 parameter error
; 0x80 timeout (other bits meaningless)
;
; packet token
; 0xFF none yet
; 0xFE ok
; or bitfield
; 0x01 error
; 0x02 controller error
; 0x04 media ecc failed
; 0x08 out of range
; 0x10 card is locked

CMD0   EQU 040h |  0 ; resets the card
CMD8   EQU 040h |  8 ; read IF_COND
CMD9   EQU 040h |  9 ; read CSD
CMD10  EQU 040h | 10 ; read CID
CMD16  EQU 040h | 16 ; set R/W block
CMD17  EQU 040h | 17 ; read block
CMD24  EQU 040h | 24 ; write block
CMD55  EQU 040h | 55 ; next command is ACMDxx
CMD58  EQU 040h | 58 ; READ_OCR
CMD59  EQU 040h | 59 ; CRC_ON_OFF
ACMD41 EQU 040h | 41 ; send host capacity support, init card

SD_PWR  EQU 08h ; POWER OFF/ON=0/1 (positive logic)
SD_CS   EQU 04h   ; NPN inverter, positive logic.
SD_CLK  EQU 02h
SD_DOUT EQU 01h
SD_DIN  EQU 80h 


#define SD_CS 32 ;0x20h
#define SD_WR 16 ;0x10h
#define SD_A0  8 ;0x08h

SD_ON:
   MVI A,0Fh
   JMP SD_CONF
SD_OFF:
   MVI A,0ch
SD_CONF:
   STA SD_CONF_PORT
   RET
SD_FIN: MVI A,0FFh
SD_PUT:
   STA SD_DATA_PORT
   NOP
   NOP
 ;===========================
;  push psw
;  call PRHEX
;  pop psw
 ;===========================
   RET
POPHRET:POP H
  RET

SD_GET:
   CALL SD_FIN
   NOP
   NOP
   LDA SD_DATA_PORT
 ;===========================
;  push psw
;  call PRHEX
;  pop psw
 ;===========================
  RET

SD_CMD: LXI H,0
SD_CMDW:LXI D,0
SD_CMDD:CALL SD_FIN
  MOV A,C
  push psw
  CALL SD_PUT
  MOV A,D
  CALL SD_PUT
  MOV A,E
  CALL SD_PUT
  MOV A,H
  CALL SD_PUT
  MOV A,L
  CALL SD_PUT
  pop psw
  cpi CMD8
  mvi A,87h
  jz putCRC
  MVI A,95h
putCRC:
  CALL SD_PUT
  LXI D,8080h
SD_WAIT:LXI H,20000
SDW_L1: CALL SD_GET
  MOV C,A    ; ld    C,A
  SUB D      ; sub   D 
  CMP E      ; cp    E
  MOV A,C    ; ld    A,C
  RNC        ; ret   nc 
  DCX H      ; dec   hl
  MOV A,H    ; ld    A,H
  ORA L      ; or    L
  JNZ SDW_L1 ; jp    nz,SDW_L1
  SUI 1      ; sub   1
  RET
       
SD_INIT:
  CALL SD_OFF
  MVI B,10h
  CALL SD_FIN
  DCR B
  JNZ $-4
  CALL SD_ON
  MVI C,CMD0
  CALL SD_CMD
  CPI 1
  RNZ
  LXI H,01AAh
  MVI C,CMD8
  CALL SD_CMDW
  CPI 01h
  jz SD_V2
SD_V1:
  MVI C,041h
  CALL SD_CMD
  ANI 0FEh     ; and   #FE
  RNZ          ; ret   nz
  MVI C,041h
  CALL SD_CMD
  CPI 1       ; cp    1
  jz SD_V1
;============================================= ;#ifdef SD_DBG_PRINT
  push PSW
  LXI H,SD_0
  CALL PRINT
  pop PSW
  jmp DBG_SD0
SD_0: DB "SDV1",0DH,0ah,0
DBG_SD0:
;#endif
;=============================================
  ora A
  ret
SD_V2:
  call SD_GET  ;read cmd8 answer
  call SD_GET
  call SD_GET
  call SD_GET
  CPI 0AAh
  jnz SD_V1 ;if here, answer must be (0x01,0x00,0x00,0x01,0xAA) if not check SD_V1
SDI_L1:
  MVI C,CMD55
  CALL SD_CMD
  ANI 0FEh     ; and   #FE
  RNZ          ; ret   nz
  LXI H,0000h
  LXI D,4000h
  MVI C,ACMD41 ; ld    C,ACMD41
  CALL SD_CMDD
  CPI 1       ; cp    1
  JZ SDI_L1   ; jp    z,SDI_L1
  MVI C,CMD58
  CALL SD_CMD
  CALL SD_GET
  ANI 040h       ; cp
  jnz SD_V2P
;=============================================
;#ifdef SD_DBG_PRINT
  push H
  LXI H,SD_1
  CALL PRINT
  pop H
  jmp DBG_SD1
SD_1: DB "SDV2",0DH,0ah,0
DBG_SD1:
;#endif
;=============================================
  CALL SD_GET
  CALL SD_GET
  CALL SD_GET
SD_V2M:
  LXI H,0200h
  MVI C,CMD16
  CALL SD_CMDW
  ORA A       ; or    A
  RET
SD_V2P:
  CALL SD_GET
  CALL SD_GET
  CALL SD_GET
;=============================================
;#ifdef SD_DBG_PRINT
  push H
  LXI H,SD_2
  CALL PRINT
  pop H
  jmp DBG_SD2
SD_2: DB "SDV2+",0DH,0ah,0
DBG_SD2:
;#endif
;=============================================
  mvi A,0ffh
  STA SDTYPE

  LXI H,0200h
  MVI C,CMD16
  CALL SD_CMDW
  ORA A       ; or    A
  RET

SD_RWR:
  PUSH D
  PUSH B
  LXI D,0FFh
  CALL SD_WAIT
  POP B
  POP H
  RC  ;  JC POPHRET
  LDA SDTYPE
  CPI 00h
  JZ SD_RWR0
  mov E,C
  MVI D,0 ;SDHC...
  stc
  cmc
  ret
SD_RWR0:
  MOV A,C
  DAD H
  ADC A
  MOV D,A
  MOV E,H
  MOV H,L
  MVI L,0
  RET

SD_READ:
  PUSH H
  call SD_RWR
  JC POPHRET
  MVI C,CMD17
  CALL SD_CMDD
  JC POPHRET
  LXI D,0FF01h
  CALL SD_WAIT
  POP H
  CPI 0FEh
  RNZ
  MVI B,0
SDR_L1: CALL SD_GET
  MOV M,A
  INX H
  CALL SD_GET
  MOV M,A
  INX H
  DCR B
  JNZ SDR_L1
  CALL SD_FIN ; aiaeaaai aua aaa ionouo aaeoa CRC - new in 8.6
  CALL SD_FIN
  RET

;#ifdef RWR ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
SD_WRITE:
  PUSH H
  call SD_RWR
  JC POPHRET
  MVI C,CMD24 ;caienu aeiea a 512 aaeo
  CALL SD_CMDD
  JC POPHRET
  POP H
  MVI A,0FEh ; ioi?aaeyai iiaoaa??aaiea
  CALL SD_PUT
  MVI B,0
SDR_WL1: ;ioi?aaeyai 512 aaeo
  MOV A,M
  INX H
  CALL SD_PUT
  MOV A,M
  INX H
  CALL SD_PUT
  DCR B
  JNZ SDR_WL1
  CALL SD_FIN ; aiaeaaai aua aaa ionouo aaeoa
  CALL SD_FIN
  RET
;#endif ;!!!!!!!!!!!!!!!!!!!!!!!!!!!

; DOS

CHKFAT: LXI H,BUF+36H
  MOV A,M
  INX H
  CPI 'F'
  RNZ
  MOV A,M
  INX H
  CPI 'A'
  RNZ
  MOV A,M
  CPI 'T'
  RET

ADDW2D: XRA A
  CALL $+3
  CALL $+3
  LDAX B
  ADC L
  STAX D
  MOV L,H
  MVI H,0
  INX B
  INX D
  RET

LD_D: MOV E,M
  INX H
  MOV D,M
  INX H
  MOV C,M
  INX H
  MOV B,M
  RET

ADD_D:  MOV A,M
  ADD E
  MOV M,A
  INX H
  MOV A,M
  ADC D
  MOV M,A
  INX H
  MOV A,M
  ADC C
  MOV M,A
  INX H
  MOV A,M
  ADC B
  MOV M,A
  RET

ADD_DR: MOV A,M
  ADD E
  MOV E,A
  INX H
  MOV A,M
  ADC D
  MOV D,A
  INX H
  MOV A,M
  ADC C
  MOV C,A
  INX H
  MOV A,M
  ADC B
  MOV B,A
  RET

SHL_D:  MOV A,E
  ADD A
  MOV E,A
  MOV A,D
  ADC A
  MOV D,A
  MOV A,C
  ADC A     ; <- PVV change from ADD A !!!!
  MOV C,A
  MOV A,B
  ADC A
  MOV B,A
  RET

MULDB:  CALL $+3
  CALL $+3
  CALL $+3
  RRC
  PUSH PSW
  JNC MULDB1
  PUSH H
  CALL ADD_D
  POP H
MULDB1: CALL SHL_D
  POP PSW
  RET

INCD: CALL INCW
  RNZ
  INX H
INCW: INR M
  RNZ
  INX H
  INR M
  RET

INCDR:  INR E
  RNZ
  INR D
  RNZ
  INR C
  RNZ
  INR B
  RET

CMPD: INX D
  INX D
  INX D
        INX H
  INX H
  INX H
  CALL $+6
  RNZ
  DCX D
  DCX H
  LDAX D
  SUB M
  RNZ
  DCX D
  DCX H
  LDAX D
  SUB M
  RET

CMPD0:  MOV A,M
  INX H
  ORA M
  INX H
  ORA M
  INX H
  ORA M
  RET

SUBHB:  MOV A,L
  SUB C
  MOV L,A
  MOV A,H
  SBB B
  MOV H,A
  RET

COPY4:  LXI B,4
COPY: MOV A,C
  ORA A
  JZ COPY1
  INR B
COPY1:  LDAX D
  MOV M,A
  INX D
  INX H
  DCR C
  JNZ COPY1
  DCR B
  JNZ COPY1
  RET

STRCMP: LDAX D
  SUB M
  RNZ
  INX D
  INX H
  DCX B
  MOV A,B
  ORA C
  JNZ STRCMP
  RET

STRCHR: MOV A,M
  CMP C
  RZ
  ORA A
  STC
  RZ
  INX H
  JMP STRCHR

STRCPY: LDAX D
  MOV M,A
  ORA A
  RZ
  INX D
  INX H
  JMP STRCPY
  
STRMSLD:LDAX D
  CPI 'a'
  RC
  CPI 'z'+1
  RNC
  ANI 0DFH
  RET

STRMASK:MVI C,11
STRMS1: CALL STRMSLD
  ORA A
  JZ STRMS5
  CPI '.'
  JZ STRMS4
  CPI '*'
  JZ STRMS6
  CPI '?'
  JZ STRMS3
STRMS2: CMP M
  RNZ
STRMS3: INX D
  INX H
  DCR C
  JNZ STRMS1
  RET
STRMS4: MOV A,C
  CPI 11
  JZ STRMS9
  CPI 4
  JC STRMS5a
  JNZ STRMS5
  INX D
STRMS5: MVI A,20H
  DCX D
  JMP STRMS2
STRMS5a:INX D
  JMP STRMS1
STRMS6: INX D
  CALL STRMSLD
  ORA A
  RZ
  MVI B,10H
  CPI '.'
  JNZ STRMS7
  MOV A,C
  SUI 2
  MOV B,A
  MVI A,20H
STRMS7: DCR B
  JZ STRMS5a
  CMP M
  JZ STRMS8
  INX H
  DCR C
  JNZ STRMS7
  ORA A
  RET
STRMS8: LDAX D
  CPI '.'
  JZ STRMS1
  JMP STRMS3
STRMS9: LDAX D
  ORA A
  JNZ $+6
  DCX D
  MVI A,20H
  CMP M
  RNZ
  INX D
  INX H
  DCR C
  JNZ STRMS9
  LDAX D
  ORA A
  RET

FS_RDBC:LXI H,BUFSEC
  MOV A,M
  CMP E
  JNZ FS_RDBF
  INX H
  MOV A,M
  CMP D
  JNZ FS_RDBF
  INX H
  MOV A,M
  CMP C
  RZ
FS_RDBF:LXI H,BUFSEC
  MOV M,E
  INX H
  MOV M,D
  INX H
  MOV M,C
  LXI H,BUF
  JMP SD_READ

;=============================================
;#ifdef SD_DBG_PRINT

DBGP_F16:
  push psw
;  push H
  LXI H,SD_F16
  CALL PRINT
;  pop H
  pop psw
  ret
SD_F16: DB "16",0dh,0ah,0

;#endif
;=============================================

FS_RST: CALL SD_INIT
  STC
  RNZ
  LXI D,0
  MOV C,E
  CALL FS_RDBF
  RC
  CALL FSRST1
  RNC
  LHLD BUF+1C6H
  XCHG
  LDA BUF+1C8H
  MOV C,A
  CALL FS_RDBF
  RC
FSRST1: CALL CHKFAT
  STC
  RNZ
;=============================================
;#ifdef SD_DBG_PRINT
  push H
  LXI H,SD_FAT
  CALL PRINT
  pop H
  jmp FSRST2E
SD_FAT: DB "SD:FAT",0
FSRST2E:
;#endif
;=============================================

  LHLD BUF+0EH
  LXI B,BUF+1CH
  LXI D,FATSEC
  CALL ADDW2D
  LHLD BUF+16H
  XCHG
  LHLD BUF+0EH
  LDA BUF+10H
  DAD D
  DCR A
  JNZ $-2
  LXI B,BUF+1CH
  LXI D,ROOTSEC
  CALL ADDW2D
  LHLD BUF+11H
  SHLD ROOTLEN
  DAD H
  ADC A
  DAD H
  ADC A
  DAD H
  ADC A
  DAD H
  ADC A
  MOV L,H
  MOV H,A
  SHLD ROOTLNS
  LXI B,ROOTSEC
  LXI D,DATASEC
  CALL ADDW2D
  LDA BUF+0DH
  STA SECINBL
  MVI A,0C3H
  STA FAT_NXT
  LDA BUF+3AH
  CPI '6'
;=============================================[
;#ifdef SD_DBG_PRINT
  CZ DBGP_F16
;#endif
;=============================================]
  LXI H,FAT_N16
FSRST2: SHLD FAT_NXT+1
  LXI H,5CH
  SHLD CWD
  XRA A
  RET

FAT_N16:
;#ifdef FAT16_ON
  LXI H,BNEXT+1
  CALL LD_D
  LXI H,FATSEC
  CALL ADD_DR
  CALL FS_RDBC
  JC FAT_EOF
  LHLD BNEXT
  MVI H,0
  DAD H
  LXI D,BUF
  DAD D
  MOV E,M
  INX H
  MOV D,M
  MOV A,E
  ORI 7
  ANA D
  INR A
  JZ FAT_EOF
  XCHG
  SHLD BNEXT
;#endif
  RET

FAT_N12:

FAT_N32:
FAT_EOF:XRA A
  MOV L,A
  MOV H,A
  SHLD BNEXT
  SHLD BNEXT+2
  RET

FS_RDWR:
   PUSH H
  LDA BLKLEN
  ORA A
  JNZ FSRD2
  LXI H,BNEXT
  CALL CMPD0
  JNZ FSRD1
  POP H
  STC
  RET
FSRD1:  LXI D,DATASEC
  LXI H,BLKSEC
  CALL COPY4
  LXI B,2
  LXI H,BNEXT
  MOV A,M
  SUB C
  MOV E,A
  INX H
  MOV A,M
  SBB B
  MOV D,A
  INX H
  MOV A,M
  SBB B
  MOV C,A
  INX H
  MOV A,M
  SBB B
  MOV B,A
  LDA SECINBL
  LXI H,BLKSEC
  CALL MULDB
  call FAT_N16 ; PVV only fat16
  LDA SECINBL
FSRD2:  DCR A
  STA BLKLEN
  LXI H,BLKSEC
  MOV E,M
  INX H
  MOV D,M
  INX H
  MOV C,M
  DCX H
  DCX H
  CALL INCD
  POP H
  RET

FS_READ: CALL FS_RDWR
  JMP SD_READ

;#ifdef RWR ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
FS_WRITE: CALL FS_RDWR
  JMP SD_WRITE
;#endif ;!!!!!!!!!!!!!!!!!!!!!!!!!!!

FS_NEXT:LDA DIRREC
  ORA A
  JNZ FSNX1
  LXI H,BUFDIR
  CALL FS_READ
  RC
  XRA A 
FSNX1:  MOV L,A
  MVI H,0
  INR A
  CPI 10H
  JC $+4
  XRA A
  STA DIRREC
  DAD H
  DAD H
  DAD H
  DAD H
  DAD H
  LXI D,BUFDIR
  DAD D
  RET

FS_FNDF:PUSH D
  LDA CWD+1
  ORA A
  JNZ FS_FF1
  CALL FAT_EOF
  LXI D,ROOTSEC
  LXI H,BLKSEC
  CALL COPY4
  LDA ROOTLNS
  JMP FS_FF2
FS_FF1: LXI D,CWDBLK
  LXI H,BNEXT
  CALL COPY4
  XRA A
FS_FF2: STA BLKLEN
  XRA A
  STA DIRREC
  POP D
FS_FNDN:PUSH D
  CALL FS_NEXT
  POP D
  RC
  PUSH H
  MVI C,20H
  XRA A
  ORA M
  INX H
  DCR C
  JNZ $-3
  POP H
  ORA A
  STC
  RZ
  MOV A,M
  CPI 0E5H
  JZ FS_FNDN
  PUSH D
  PUSH H
  CALL STRMASK
  POP H
  POP D
  RZ
  JMP FS_FNDN

FS_GETB:LXI D,20
  DAD D
  MOV C,M
  INX H
  MOV B,M
  LXI D,5
  DAD D
  MOV E,M
  INX H
  MOV D,M
  RET

FS_CHDIR:LDAX D
  SUI 5CH
  JNZ FS_CD1
  STA CWD+1
  INX D
  LDAX D
  ORA A
  RZ
FS_CD1: PUSH D
FS_CD2: LDAX D
  ORA A
  JZ FS_CD3
  INX D
  SUI 5CH
  JNZ FS_CD2
  DCX D
  STAX D
  INX D
FS_CD3: XCHG
  POP D
  PUSH H
  PUSH D
  CALL FS_FNDF
  POP B
  JC FS_CD4
  PUSH H
  LXI D,11
  DAD D
  MOV A,M
  POP H
  RLC
  RLC
  RLC
  RLC
  CMC
FS_CD4: POP D
  RC
  PUSH D
  PUSH B
  CALL FS_GETB
  LXI H,CWDBLK
  MOV M,E
  INX H
  MOV M,D
  INX H
  MOV M,C
  INX H
  MOV M,B
  POP D
  LXI H,CWD
  MOV A,M
  INX H
  MOV B,A
  MOV A,M
  ORA A
  JNZ $-4
  LDAX D
  CPI '.'
  JNZ FS_CD5
  INX D
  LDAX D
  CPI '.'
  JNZ FS_CD6
  DCX H
  MOV A,M
  MVI M,0
  CPI 5CH
  JNZ $-6
  STA CWD
  JMP FS_CD6
FS_CD5: MOV A,B
  CPI 5CH
  JZ $+6
  MVI M,5CH
  INX H
  CALL STRCPY
FS_CD6: POP D
  LDAX D
  ORA A
  JNZ FS_CD1
  RET

F_OPEN: LXI H,0
  SHLD FBLEN
FS_OPEN:CALL FS_FNDF
  RC
  CALL FS_GETB
  LXI H,BNEXT
  MOV M,E
  INX H
  MOV M,D
  INX H
  MOV M,C
  INX H
  MOV M,B
  XRA A
  STA BLKLEN
  RET

F_READ: MOV A,B
  ORA C
  RZ
  PUSH H
  LHLD FBLEN
  MOV A,H
  ORA L
  JZ F_RD1
  CALL SUBHB
  JNC F_RD3
  POP D
  PUSH B
  LHLD FBLEN
  MOV B,H
  MOV C,L
  POP H
  CALL SUBHB
  PUSH H
  LHLD FBPOS
  XCHG
  CALL COPY
  POP B
  PUSH H
F_RD1:  MOV A,B
  CPI 2
  JNC F_RD2
  PUSH B
  LXI H,200H
  SHLD FBLEN
  LXI H,BUFDIR
  SHLD FBPOS
  CALL FS_READ
  POP B
  POP H
  JNC F_READ
  RET
F_RD2:  LXI H,0
  SHLD FBLEN
  POP H
  PUSH B
  CALL FS_READ
  POP B
  RC
  DCR B
  DCR B
  JMP F_READ
F_RD3:  SHLD FBLEN
  LHLD FBPOS
  XCHG
  POP H
  CALL COPY
  XCHG
  SHLD FBPOS
  XCHG
  RET

;#ifdef RWR ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
F_WRITE: MOV A,B
  ORA C
  RZ
  PUSH H
  LHLD FBLEN
  MOV A,H
  ORA L
  JZ F_WR1
  POP H
  RET
F_WR1:  MOV A,B
  CPI 2
  JNC F_WR2
  LXI H,200H
  SHLD FBLEN
  POP H
  PUSH B
  CALL FS_WRITE
  POP B
  JNC F_WRITE
  RET
F_WR2:  LXI H,0
  SHLD FBLEN
  POP H
  PUSH B
  CALL FS_WRITE
  POP B
  RC
  DCR B
  DCR B
  JMP F_WRITE
;#endif ;!!!!!!!!!!!!!!!!!!!!!!!!!!!

   .end