.xlist
  .8086
  
CGROUP  GROUP TEXT

TEXT  segment byte public 'CODE'
  assume  CS:CGROUP, DS:CGROUP, es:nothing, ss:nothing,

; 
ROMCALL MACRO ADDR
  MOV BP,ADDR
  CALL  BP
  ENDM
; 

;#ifdef RK86
GETC  EQU 0F803H
PUTC  EQU 0F809H
PRINT EQU 0F818H
PRHEX EQU 0F815H
IFKEYPRESS EQU 0F81BH
SD_DATA_PORT EQU 0D000H
SD_CONF_PORT EQU 0D001H
START_ADDR   EQU 0E000H
BUF     EQU 0d800H
;#endif
;==========================================================

BUFDIR  EQU BUF+0200H
CWDS    EQU BUF+0400H
FATSEC  EQU BUF+0500H

ROOTSEC EQU FATSEC+4
DATASEC EQU ROOTSEC+4
ROOTLEN EQU DATASEC+4
ROOTLNS EQU ROOTLEN+2
SECINBL EQU ROOTLNS+2
FAT_NXT EQU SECINBL+1
BUFSEC  EQU FAT_NXT+3
BLKLEN  EQU BUFSEC+4
BLKSEC  EQU BLKLEN+1
BNEXT   EQU BLKSEC+4
FBPOS   EQU BNEXT+4
FBLEN   EQU FBPOS+2
DIRREC  EQU FBLEN+2
CWDBLK  EQU DIRREC+1
LINEBUF EQU CWDBLK+4
SDTYPE  EQU LINEBUF+38H

  ORG START_ADDR

;CALL FS_FNDF ; DE - name of file for finding, out HL - string FAT record of fi
;CALL F_OPEN ; DE - name of file for opening, out C==1 if file not founded
;CALL F_READ ; HL - addr for store readed data, BC - size of readed data

ENTRY:
;=============================================
  MOV BX,OFFSET TSD_INIT
  ROMCALL PRINT
  JMP DBG_SDINIT
TSD_INIT DB "SDOS-8086_V8.6",0DH,0AH,0
DBG_SDINIT:
;=============================================
  MOV BX,OFFSET BUF
  MOV CX,OFFSET 2048-256
CLRMEM:
  MOV BYTE PTR [BX],0
  INC BX
  DEC CX
  MOV AL,CL
  OR AL,CH
  JNZ CLRMEM
  CALL FS_RST
LOOPS:   MOV CL,38H
  MOV BX,OFFSET LINEBUF
LOOP0:
  MOV BYTE PTR [BX],0
  INC BX
  DEC CL
  JNZ LOOP0
  MOV BX,OFFSET A_DRIVE
  ROMCALL PRINT
  MOV BX,OFFSET CWDS
  ROMCALL PRINT
  MOV CL,'>'
  ROMCALL PUTC
  CALL READLN
  MOV BX,OFFSET LOOPS
  PUSH BX
  MOV BX,OFFSET CMDLST
LOOP1:  MOV AL,[BX]
  OR AL,AL
  JNZ $+5
  JMP RUNFILE
  MOV DX,OFFSET LINEBUF
LOOP2:  MOV AL,[BX]
  OR AL,AL
  JZ LOOP3
  XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  CMP AL,[BX]
  JNZ LOOP4
  INC DX
  INC BX
  JMP LOOP2
LOOP3:  
  XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  OR AL,AL
  JZ LOOP5
  CMP AL,20H
  JZ LOOP5
LOOP4:  MOV AL,[BX]
  INC BX
  OR AL,AL
  JNZ LOOP4
  INC BX
  INC BX
  JMP LOOP1
LOOP5:  INC BX
  MOV DL,[BX]
  INC BX
  MOV DH,[BX]
  CALL PRINT_NEWLINE
  XCHG BX,DX
  JMP BX

PRINTN: MOV CL,[BX]
  INC BX
  ROMCALL PUTC
  DEC CH
  JNZ PRINTN
  RET

PRINTS:
  ROMCALL PRINT
  RET

C_DIR:
  MOV DX,OFFSET LINEBUF+2
C_DIR0:
  INC DX
  XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  CMP AL,20H
  JZ C_DIR0
  OR AL,AL
  JNZ C_DIR01
  MOV DX,OFFSET ALLFILS
C_DIR01:
  CALL FS_FNDF
  JC C_DIRNO 
C_DIR1: 
  PUSH BX
CALL_KEYPR:
  ROMCALL IFKEYPRESS ; ii?in ia?aoey eiiiie 
  CMP AL,0FFH   ; i?einoaiiaea auaiaa nienea oaeeia anee anou ia?aoea e?aie eiiie
  JNZ CALL_KEYPR
  MOV CX,OFFSET 11
  ADD BX,CX
  MOV AL,[BX]
  POP BX
  AND AL,8
  JNZ C_DIR2
  MOV CH,8
  CALL PRINTN
  MOV CL,' '
  ROMCALL PUTC
  MOV CH,3
  CALL PRINTN
  MOV CL,' '
  ROMCALL PUTC
  MOV AL,[BX]
  AND AL,010H
  JZ C_DIR11
  MOV BX,OFFSET NODIR+4 ;_DIR   CALL PRINT
  JMP C_DIR12
C_DIR11:
  MOV AL,BL
  ADD AL,012H
  MOV BL,AL
  MOV AL,[BX]
  ROMCALL PRHEX
  DEC BX
  MOV AL,[BX]
  ROMCALL PRHEX
C_DIR12:
  CALL PRINT_NEWLINE
C_DIR2: CALL FS_FNDN
  JNC C_DIR1
  RET
C_DIRNO_POPH:
  POP BX
C_DIRNO:MOV BX,OFFSET NOFILES
  JMP PRINTS

C_CD: MOV BX,OFFSET LINEBUF+1
C_CDD:
  INC BX
  MOV AL,[BX]
  CMP AL,20H
  JZ C_CDD
  OR AL,AL
  JNZ C_CD1
  CALL PRINT_NEWLINE
  MOV BX,OFFSET CWDS
  JMP PRINTS
C_CD1:  XCHG BX,DX
  CALL FS_CHDIR
  JC $+3
  RET
  MOV BX,OFFSET NODIR
  JMP PRINTS

C_I:
  CALL SD_OFF
  POP BX
  JMP ENTRY ;START_ADDR

C_X:
  CALL SD_OFF
;  JMP 0F800H
  mov BP,OFFSET 0F800H
  push BP
  ret

;#ifdef RWR ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
C_RWR:
  MOV DX,OFFSET LINEBUF+2
  CALL F_OPEN
  JNC $+4
  JMP C_DIRNO ; no file
  MOV BX,OFFSET LINEBUF+2
C_RWR1:
  MOV AL,[BX]
  CMP AL,0
  JZ C_RWR2
  CMP AL,2CH
  PUSHF
  INC BX
  POPF
  JNZ C_RWR1
C_RWR2:
  CALL R65
  MOV BX,OFFSET ERRS
  JNC $+5
  JMP PRINTS
  MOV BX,word ptr DS:(LINEBUF+26) ;size iaeanoe
  MOV CL,BL   ;
  MOV CH,BH   ;
  MOV BX,word ptr DS:(LINEBUF+24) ;AA?AN  ia?aea iaeanoe
  MOV DX,OFFSET LINEBUF
  XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  CMP AL,'R'
  JZ C_RWR3
  CALL F_WRITE
  JMP C_RWR4
C_RWR3:
  CALL F_READ
C_RWR4:
;#endif ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
  MOV BX,OFFSET RWR_OK
  JMP PRINTS

;**********************************************
RUNFILE:    ;RK-86
  CALL PRINT_NEWLINE
  MOV BX,OFFSET LINEBUF
  MOV CL,'.'
  CALL STRCHR
  JNC RUNF1
  MOV DX,OFFSET DOTRK
  CALL STRCPY
RUNF1:  MOV DX,OFFSET LINEBUF
  CALL F_OPEN
  JNC $+5
  JMP C_DIRNO ; no file
RD_4B:
  MOV CX,OFFSET 4 ; ?eoaai ec RK? oaeea aa?an noa?oa i?ia?aiiu/eoaa neeaauaaou a iaiyoe
  MOV BX,OFFSET LINEBUF
  PUSH BX
  CALL F_READ
  POP BX
  MOV DH,[BX]
  INC BX
  MOV DL,[BX]
  INC BX
  MOV CH,[BX]
  INC BX
  MOV AL,[BX]
  SUB AL,DL
  MOV CL,AL
  MOV AL,CH
  SBB AL,DH
  MOV CH,AL
  INC CX    ;?acia? oaeea
  XCHG BX,DX
  PUSH BX   ;nio?aiyai aa?an noa?oa, a ret iinea F_READ naaeaao ia?aoia ia yoio aa
  PUSH CX
  PUSH CX
  MOV AL,BH
  ROMCALL PRHEX
  MOV AL,BL
  ROMCALL PRHEX
  MOV CL,','
  ROMCALL PUTC
  MOV AL,CH
  ROMCALL PRHEX
  POP CX
  MOV AL,CL
  ROMCALL PRHEX
  POP CX
  CALL F_READ
  JMP SD_OFF

READLN: MOV BX,OFFSET LINEBUF
READL1:
  ROMCALL GETC
  CMP AL,8
  JZ READL3
  CMP AL,5FH
  JZ READL3
  CMP AL,18H
  JZ READL4
  MOV BYTE PTR [BX],0
  CMP AL,0DH
  JNZ $+3
  RET
  MOV [BX],AL
  INC BX
READL2: MOV CL,AL
  ROMCALL PUTC
  JMP READL1
READL3: MOV AL,BL
  CMP AL,LOW(LINEBUF) ; & 255
  JZ READL1
  MOV CL,8
  ROMCALL PUTC
  MOV CL,20H
  ROMCALL PUTC
  MOV CL,8
  ROMCALL PUTC
  DEC BX
  JMP READL1
READL4: MOV AL,[BX]
  OR AL,AL
  JZ READL1
  CMP AL,0DH
  JZ READL1
  INC BX
  JMP READL2
;**********************************************
;#ifdef RWR ;!!!!!!!!!!!!!!!!!!!!!!!!!!!

SET_LAST_SPACE:
  INC DX
  PUSH DX
  MOV CL,0AH
R66:
  XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  CMP AL,0
  JNZ R68
  MOV AL,20H
  XCHG BX,DX
  MOV [BX],AL
  XCHG BX,DX
  JMP R67
R68:
  INC DX
  DEC CL
  JNZ R66
R67:
  POP DX
  RET
;**********************************************
;Iiai?ia?aiia aaiaa aa?ania aey ooieoee
;**********************************************
R65:
  XCHG BX,DX
  MOV BX,OFFSET 0
  MOV word ptr DS:(LINEBUF+24),BX
  MOV word ptr DS:(LINEBUF+26),BX
  CALL R7C
  MOV word ptr DS:(LINEBUF+24),BX
  JNC $+3
  RET
  CALL R7C
  MOV word ptr DS:(LINEBUF+26),BX
  RET
;*********************************************
;Iiai?ia?aiia aaiaa iaiiai 16 aa?ana
;*********************************************
R7C:
      MOV BX,OFFSET 0
      MOV CH,0
R7F:
      XCHG BX,DX
      MOV AL,[BX]
      XCHG BX,DX
      INC DX
      CMP AL,00H
      JZ R7E
      CMP AL,2CH
      JNZ $+3
      RET
      CMP AL,20H
      JZ R7F
      SUB AL,30H
      JS R79
      CMP AL,0AH
      JS R80
      CMP AL,11H
      JS R79
      CMP AL,17H
      JNS R79
      SUB AL,07H
R80:
      MOV CL,AL
      ADD BX,BX
      ADD BX,BX
      ADD BX,BX
      ADD BX,BX
      JC R79
      ADD BX,CX
      JMP R7F
R79:
  STC
R7E:
      RET
;#endif ;!!!!!!!!!!!!!!!!!!!!!!!!!!!

;*********************************************
PRINT_NEWLINE:
  MOV BX,OFFSET NEWLINE
  ROMCALL PRINT
  RET

NEWLINE: DB 0DH,0AH,0
A_DRIVE: DB 0DH,0AH,"A:",0
NOFILES: DB "NO FILE(S)",0

RWR_OK:  DB "OK",0DH,0
ERRS:    DB "ERR",0DH,0
ALLFILS: DB "*",0

DOTRK:  DB ".R86",0
NODIR:  DB 0DH,"NO "  
CMDLST: DB "DIR",0
        DW C_DIR
        DB "CD",0
        DW C_CD
        DB "X",0
        DW C_X
;#ifdef RWR ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
        DB "R",0
        DW C_RWR
        DB "W",0
        DW C_RWR
;#endif ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
        DB "I",0
        DW C_I
        DB 0

;http://elm-chan.org/docs/mmc/ima/sdinit.png
; command response R1
; 0x00 ok
; or bitfield
; 0x01 idle state
; 0x02 erase reset
; 0x04 illegal command
; 0x08 command crc error
; 0x10 erase sequence error
; 0x20 address error
; 0x40 parameter error
; 0x80 timeout (other bits meaningless)
;
; packet token
; 0xFF none yet
; 0xFE ok
; or bitfield
; 0x01 error
; 0x02 controller error
; 0x04 media ecc failed
; 0x08 out of range
; 0x10 card is locked

CMD0   EQU 040H ;|  0  ; resets the card
CMD8   EQU 048H ;|  8  ; read IF_COND
;CMD9   EQU 040H |  9  ; read CSD
;CMD10  EQU 040H | 10  ; read CID
CMD16  EQU 050h ;040H | 16  ; set R/W block
CMD17  EQU 051h ;040H | 17  ; read block
CMD24  EQU 058h ;040H | 24  ; write block
CMD55  EQU 077h ;040H | 55  ; next command is ACMDxx
CMD58  EQU 07ah ;040H | 58  ; READ_OCR
;CMD59  EQU 040H | 59  ; CRC_ON_OFF
ACMD41 EQU 069h ;040H | 41  ; send host capacity support, init card

SD_ON:
   MOV AL,0FH
   JMP SD_CONF
SD_OFF:
   MOV AL,0CH
SD_CONF:
   MOV byte ptr DS:SD_CONF_PORT,AL
   RET
SD_FIN: MOV AL,0FFH
SD_PUT:
   MOV byte ptr DS:SD_DATA_PORT,AL
   NOP
   NOP
      ;===========================
;  push psw
;  call PRHEX
;  pop psw
      ;===========================
   RET
POPHRET:POP BX
  RET

SD_GET:
   CALL SD_FIN
   NOP
   NOP
   MOV AL,byte ptr DS:SD_DATA_PORT
      ;===========================
;  push psw
;  call PRHEX
;  pop psw
      ;===========================
  RET

SD_CMD: MOV BX,OFFSET 0
SD_CMDW:MOV DX,OFFSET 0
SD_CMDD:CALL SD_FIN
  MOV AL,CL
  LAHF
  PUSH AX
  CALL SD_PUT
  MOV AL,DH
  CALL SD_PUT
  MOV AL,DL
  CALL SD_PUT
  MOV AL,BH
  CALL SD_PUT
  MOV AL,BL
  CALL SD_PUT
  POP AX
  SAHF
  CMP AL,CMD8
  MOV AL,87H
  JZ PUTCRC
  MOV AL,95H
PUTCRC:
  CALL SD_PUT
  MOV DX,OFFSET 8080H
SD_WAIT:MOV BX,OFFSET 20000
SDW_L1: CALL SD_GET
  MOV CL,AL
  SUB AL,DH
  CMP AL,DL
  MOV AL,CL
  JC $+3
  RET
  DEC BX
  MOV AL,BH
  OR AL,BL
  JNZ SDW_L1
  SUB AL,1
  RET

SD_INIT:
  CALL SD_OFF
  MOV CH,10H
SD_INIT1:
  CALL SD_FIN
  DEC CH
  JNZ SD_INIT1
  CALL SD_ON
  MOV CL,CMD0
  CALL SD_CMD
  CMP AL,1
  JZ $+3
  RET
  MOV BX,OFFSET 01AAH
  MOV CL,OFFSET CMD8
  CALL SD_CMDW
  CMP AL,01H
  JZ SD_V2
SD_V1:
  MOV CL,041H
  CALL SD_CMD
  AND AL,0FEH   ; and   #FE
  JZ $+3
  RET    ; ret   nz
  MOV CL,041H
  CALL SD_CMD
  CMP AL,1    ; cp    1
  JZ SD_V1
;============================================= ;#ifdef SD_DBG_PRINT
  LAHF
  PUSH AX
  MOV BX,OFFSET SD_0
  ROMCALL PRINT
  POP AX
  SAHF
  JMP DBG_SD0
SD_0: DB "SDV1",0DH,0AH,0
DBG_SD0:
;#endif
;=============================================
  OR AL,AL
  RET
SD_V2:
  CALL SD_GET   ;read cmd8 answer
  CALL SD_GET
  CALL SD_GET
  CALL SD_GET
  CMP AL,0AAH
  JNZ SD_V1  ;if here, answer must be (0x01,0x00,0x00,0x01,0xAA) if not check SD
SDI_L1:
  MOV CL,CMD55
  CALL SD_CMD
  AND AL,0FEH   ; and   #FE
  JZ $+3
  RET
  MOV BX,OFFSET 0000H
  MOV DX,OFFSET 4000H
  MOV CL,ACMD41
  CALL SD_CMDD
  CMP AL,1
  JZ SDI_L1
  MOV CL,CMD58
  CALL SD_CMD
  CALL SD_GET
  AND AL,040H   ; cp
  JNZ SD_V2P
;=============================================
;#ifdef SD_DBG_PRINT
  PUSH BX
  MOV BX,OFFSET SD_1
  ROMCALL PRINT
  POP BX
  JMP DBG_SD1
SD_1: DB "SDV2",0DH,0AH,0
DBG_SD1:
;#endif
;=============================================
  CALL SD_GET
  CALL SD_GET
  CALL SD_GET
SD_V2M:
  MOV BX,OFFSET 0200H
  MOV CL,CMD16
  CALL SD_CMDW
  OR AL,AL    ; or    A
  RET
SD_V2P:
  CALL SD_GET
  CALL SD_GET
  CALL SD_GET
;=============================================
;#ifdef SD_DBG_PRINT
  PUSH BX
  MOV BX,OFFSET SD_2
  ROMCALL PRINT
  POP BX
  JMP DBG_SD2
SD_2 DB "SDV2+",0DH,0AH,0
DBG_SD2:
;#endif
;=============================================
  MOV AL,0FFH
  MOV byte ptr DS:SDTYPE,AL

  MOV BX,OFFSET 0200H
  MOV CL,CMD16
  CALL SD_CMDW
  OR AL,AL    ; or    A
  RET

SD_RWR:
  PUSH DX
  PUSH CX
  MOV DX,OFFSET 0FFH
  CALL SD_WAIT
  POP CX
  POP BX
  JNC $+3
  RET   ;  JC POPHRET
  MOV AL,byte ptr DS:SDTYPE
  CMP AL,00H
  JZ SD_RWR0
  MOV DL,CL
  MOV DH,0    ;SDHC...
  STC
  CMC
  RET
SD_RWR0:
  MOV AL,CL
  ADD BX,BX
  ADC AL,AL
  MOV DH,AL
  MOV DL,BH
  MOV BH,BL
  MOV BL,0
  RET

SD_READ:
  PUSH BX
  CALL SD_RWR
  JNC $+5
  JMP POPHRET
  MOV CL,CMD17
  CALL SD_CMDD
  JNC $+5
  JMP POPHRET
  MOV DX,OFFSET 0FF01H
  CALL SD_WAIT
  POP BX
  CMP AL,0FEH
  JZ $+3
  RET
  MOV CH,0
SDR_L1: CALL SD_GET
  MOV [BX],AL
  INC BX
  CALL SD_GET
  MOV [BX],AL
  INC BX
  DEC CH
  JNZ SDR_L1
  CALL SD_FIN   ; aiaeaaai aua aaa ionouo aaeoa CRC - new in 8.6
  CALL SD_FIN
  RET

;#ifdef RWR ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
SD_WRITE:
  PUSH BX
  CALL SD_RWR
  JNC $+5
  JMP POPHRET
  MOV CL,CMD24    ;caienu aeiea a 512 aaeo
  CALL SD_CMDD
  JNC $+5
  JMP POPHRET
  POP BX
  MOV AL,0FEH   ; ioi?aaeyai iiaoaa??aaiea
  CALL SD_PUT
  MOV CH,0
SDR_WL1:    ;ioi?aaeyai 512 aaeo
  MOV AL,[BX]
  INC BX
  CALL SD_PUT
  MOV AL,[BX]
  INC BX
  CALL SD_PUT
  DEC CH
  JNZ SDR_WL1
  CALL SD_FIN   ; aiaeaaai aua aaa ionouo aaeoa
  CALL SD_FIN
  RET
;#endif ;!!!!!!!!!!!!!!!!!!!!!!!!!!!

; DOS

CHKFAT: MOV BX,OFFSET BUF+36H
  MOV AL,[BX]
  INC BX
  CMP AL,'F'
  JZ $+3
  RET
  MOV AL,[BX]
  INC BX
  CMP AL,'A'
  JZ $+3
  RET
  MOV AL,[BX]
  CMP AL,'T'
  RET

ADDW2D: XOR AL,AL
  CALL ADDW2D1
ADDW2D1:
  CALL ADDW2D2
ADDW2D2:
  XCHG BX,CX
  MOV AL,[BX]
  XCHG BX,CX
  ADC AL,BL
  XCHG BX,DX
  MOV [BX],AL
  XCHG BX,DX
  MOV BL,BH
  MOV BH,0
  INC CX
  INC DX
  RET

LD_D: MOV DL,[BX]
  INC BX
  MOV DH,[BX]
  INC BX
  MOV CL,[BX]
  INC BX
  MOV CH,[BX]
  RET

ADD_D:  MOV AL,[BX]
  ADD AL,DL
  MOV [BX],AL
  INC BX
  MOV AL,[BX]
  ADC AL,DH
  MOV [BX],AL
  INC BX
  MOV AL,[BX]
  ADC AL,CL
  MOV [BX],AL
  INC BX
  MOV AL,[BX]
  ADC AL,CH
  MOV [BX],AL
  RET

ADD_DR: MOV AL,[BX]
  ADD AL,DL
  MOV DL,AL
  INC BX
  MOV AL,[BX]
  ADC AL,DH
  MOV DH,AL
  INC BX
  MOV AL,[BX]
  ADC AL,CL
  MOV CL,AL
  INC BX
  MOV AL,[BX]
  ADC AL,CH
  MOV CH,AL
  RET

SHL_D:  MOV AL,DL
  ADD AL,AL
  MOV DL,AL
  MOV AL,DH
  ADC AL,AL
  MOV DH,AL
  MOV AL,CL
  ADC AL,AL   ; <- PVV change from ADD A !!!!
  MOV CL,AL
  MOV AL,CH
  ADC AL,AL
  MOV CH,AL
  RET

MULDB:  CALL $+3
  CALL $+3
  CALL $+3
  ROR AL,1
  LAHF
  PUSH AX
  JNC MULDB1
  PUSH BX
  CALL ADD_D
  POP BX
MULDB1: CALL SHL_D
  POP AX
  SAHF
  RET

INCD: CALL INCW
  JZ $+3
  RET
  INC BX
INCW: INC BYTE PTR [BX]
  JZ $+3
  RET
  INC BX
  INC BYTE PTR [BX]
  RET

INCDR:  INC DL
  JZ $+3
  RET
  INC DH
  JZ $+3
  RET
  INC CL
  JZ $+3
  RET
  INC CH
  RET

CMPD: INC DX
  INC DX
  INC DX
  INC BX
  INC BX
  INC BX
  CALL CMPDD
  JZ $+3
  RET
  DEC DX
  DEC BX
CMPDD:
  XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  SUB AL,[BX]
  JZ $+3
  RET
  DEC DX
  DEC BX
  XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  SUB AL,[BX]
  RET

CMPD0:  MOV AL,[BX]
  INC BX
  OR AL,[BX]
  INC BX
  OR AL,[BX]
  INC BX
  OR AL,[BX]
  RET

SUBHB:  MOV AL,BL
  SUB AL,CL
  MOV BL,AL
  MOV AL,BH
  SBB AL,CH
  MOV BH,AL
  RET

COPY4:  MOV CX,OFFSET 4
COPY: MOV AL,CL
  OR AL,AL
  JZ COPY1
  INC CH
COPY1:  XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  MOV [BX],AL
  INC DX
  INC BX
  DEC CL
  JNZ COPY1
  DEC CH
  JNZ COPY1
  RET

STRCMP: XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  SUB AL,[BX]
  JZ $+3
  RET
  INC DX
  INC BX
  DEC CX
  MOV AL,CH
  OR AL,CL
  JNZ STRCMP
  RET

STRCHR: MOV AL,[BX]
  CMP AL,CL
  JNZ $+3
  RET
  OR AL,AL
  STC
  JNZ $+3
  RET
  INC BX
  JMP STRCHR

STRCPY: XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  MOV [BX],AL
  OR AL,AL
  JNZ $+3
  RET
  INC DX
  INC BX
  JMP STRCPY

STRMSLD:XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  CMP AL,'a'
  JNC $+3
  RET
  CMP AL,'z'+1
  JC $+3
  RET
  AND AL,0DFH
  RET

STRMASK:MOV CL,11
STRMS1: CALL STRMSLD
  OR AL,AL
  JZ STRMS5
  CMP AL,'.'
  JZ STRMS4
  CMP AL,'*'
  JZ STRMS6
  CMP AL,'?'
  JZ STRMS3
STRMS2: CMP AL,[BX]
  JZ $+3
  RET
STRMS3: INC DX
  INC BX
  DEC CL
  JNZ STRMS1
  RET
STRMS4: MOV AL,CL
  CMP AL,11
  JZ STRMS9
  CMP AL,4
  JC STRMS5A
  JNZ STRMS5
  INC DX
STRMS5: MOV AL,20H
  DEC DX
  JMP STRMS2
STRMS5A:INC DX
  JMP STRMS1
STRMS6: INC DX
  CALL STRMSLD
  OR AL,AL
  JNZ $+3
  RET
  MOV CH,10H
  CMP AL,'.'
  JNZ STRMS7
  MOV AL,CL
  SUB AL,2
  MOV CH,AL
  MOV AL,20H
STRMS7: DEC CH
  JZ STRMS5A
  CMP AL,[BX]
  JZ STRMS8
  INC BX
  DEC CL
  JNZ STRMS7
  OR AL,AL
  RET
STRMS8: XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  CMP AL,'.'
  JZ STRMS1
  JMP STRMS3
STRMS9: XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  OR AL,AL
  JNZ STRMS91
  DEC DX
  MOV AL,20H
STRMS91:
  CMP AL,[BX]
  JZ $+3
  RET
  INC DX
  INC BX
  DEC CL
  JNZ STRMS9
  XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  OR AL,AL
  RET

FS_RDBC:MOV BX,OFFSET BUFSEC
  MOV AL,[BX]
  CMP AL,DL
  JNZ FS_RDBF
  INC BX
  MOV AL,[BX]
  CMP AL,DH
  JNZ FS_RDBF
  INC BX
  MOV AL,[BX]
  CMP AL,CL
  JNZ $+3
  RET
FS_RDBF:MOV BX,OFFSET BUFSEC
  MOV [BX],DL
  INC BX
  MOV [BX],DH
  INC BX
  MOV [BX],CL
  MOV BX,OFFSET BUF
  JMP SD_READ

;=============================================
;#ifdef SD_DBG_PRINT

DBGP_F16:
  LAHF
  PUSH AX
  MOV BX,OFFSET SD_F16
  ROMCALL PRINT
  POP AX
  SAHF
  RET
SD_F16: DB "16",0DH,0AH,0

;#endif
;=============================================

FS_RST: CALL SD_INIT
  STC
  JZ $+3
  RET
  MOV DX,OFFSET 0
  MOV CL,DL
  CALL FS_RDBF
  JNC $+3
  RET
  CALL FSRST1
  JC $+3
  RET
  MOV BX,word ptr DS:(BUF+1C6H)
  XCHG BX,DX
  MOV AL,byte ptr DS:(BUF+1C8H)
  MOV CL,AL
  CALL FS_RDBF
  JNC $+3
  RET
FSRST1: CALL CHKFAT
  STC
  JZ $+3
  RET
;=============================================
;#ifdef SD_DBG_PRINT
  PUSH BX
  MOV BX,OFFSET SD_FAT
  ROMCALL PRINT
  POP BX
  JMP FSRST2E
SD_FAT: DB "SD:FAT",0
FSRST2E:
;#endif
;=============================================

  MOV BX,word ptr DS:(BUF+0EH)
  MOV CX,OFFSET BUF+1CH
  MOV DX,OFFSET FATSEC
  CALL ADDW2D
  MOV BX,word ptr DS:(BUF+16H)
  XCHG BX,DX
  MOV BX,word ptr DS:(BUF+0EH)
  MOV AL,byte ptr DS:(BUF+10H)
FSRST2E1:
  ADD BX,DX
  DEC AL
  JNZ FSRST2E1
  MOV CX,OFFSET BUF+1CH
  MOV DX,OFFSET ROOTSEC
  CALL ADDW2D
  MOV BX,word ptr DS:(BUF+11H)
  MOV word ptr DS:ROOTLEN,BX
  ADD BX,BX
  ADC AL,AL
  ADD BX,BX
  ADC AL,AL
  ADD BX,BX
  ADC AL,AL
  ADD BX,BX
  ADC AL,AL
  MOV BL,BH
  MOV BH,AL
  MOV word ptr DS:ROOTLNS,BX
  MOV CX,OFFSET ROOTSEC
  MOV DX,OFFSET DATASEC
  CALL ADDW2D
  MOV AL,byte ptr DS:(BUF+0DH)
  MOV byte ptr DS:SECINBL,AL
  MOV AL,0C3H
  MOV byte ptr DS:FAT_NXT,AL
  MOV AL,byte ptr DS:(BUF+3AH)
  CMP AL,'6'
;=============================================[
;#ifdef SD_DBG_PRINT
  JNZ $+5
  CALL DBGP_F16
;#endif
;=============================================]
  MOV BX,OFFSET FAT_N16
FSRST2: MOV word ptr DS:(FAT_NXT+1),BX
  MOV BX,OFFSET 5CH
  MOV word ptr DS:CWDS,BX
  XOR AL,AL
  RET

FAT_N16:
;#ifdef FAT16_ON
  MOV BX,OFFSET BNEXT+1
  CALL LD_D
  MOV BX,OFFSET FATSEC
  CALL ADD_DR
  CALL FS_RDBC
  JC FAT_EOF
  MOV BX,word ptr DS:BNEXT
  MOV BH,0
  ADD BX,BX
  MOV DX,OFFSET BUF
  ADD BX,DX
  MOV DL,[BX]
  INC BX
  MOV DH,[BX]
  MOV AL,DL
  OR AL,7
  AND AL,DH
  INC AL
  JZ FAT_EOF
  XCHG BX,DX
  MOV word ptr DS:BNEXT,BX
;#endif
  RET

FAT_N12:
FAT_N32:
FAT_EOF:XOR AL,AL
  MOV BL,AL
  MOV BH,AL
  MOV word ptr DS:BNEXT,BX
  MOV word ptr DS:(BNEXT+2),BX
  RET

FS_RDWR:
  PUSH BX
  MOV AL,byte ptr DS:BLKLEN
  OR AL,AL
  JNZ FSRD2
  MOV BX,OFFSET BNEXT
  CALL CMPD0
  JNZ FSRD1
  POP BX
  STC
  RET
FSRD1:  MOV DX,OFFSET DATASEC
  MOV BX,OFFSET BLKSEC
  CALL COPY4
  MOV CX,OFFSET 2
  MOV BX,OFFSET BNEXT
  MOV AL,[BX]
  SUB AL,CL
  MOV DL,AL
  INC BX
  MOV AL,[BX]
  SBB AL,CH
  MOV DH,AL
  INC BX
  MOV AL,[BX]
  SBB AL,CH
  MOV CL,AL
  INC BX
  MOV AL,[BX]
  SBB AL,CH
  MOV CH,AL
  MOV AL,byte ptr DS:SECINBL
  MOV BX,OFFSET BLKSEC
  CALL MULDB
  CALL FAT_N16    ; PVV only fat16
  MOV AL,byte ptr DS:SECINBL
FSRD2:  DEC AL
  MOV byte ptr DS:BLKLEN,AL
  MOV BX,OFFSET BLKSEC
  MOV DL,[BX]
  INC BX
  MOV DH,[BX]
  INC BX
  MOV CL,[BX]
  DEC BX
  DEC BX
  CALL INCD
  POP BX
  RET

FS_READ: CALL FS_RDWR
  JMP SD_READ

;#ifdef RWR ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
FS_WRITE: CALL FS_RDWR
  JMP SD_WRITE
;#endif ;!!!!!!!!!!!!!!!!!!!!!!!!!!!

FS_NEXT:MOV AL,byte ptr DS:DIRREC
  OR AL,AL
  JNZ FSNX1
  MOV BX,OFFSET BUFDIR
  CALL FS_READ
  JNC $+3
  RET
  XOR AL,AL
FSNX1:  MOV BL,AL
  MOV BH,0
  INC AL
  CMP AL,10H
  JC FSNX2
  XOR AL,AL
FSNX2:
  MOV byte ptr DS:DIRREC,AL
  ADD BX,BX
  ADD BX,BX
  ADD BX,BX
  ADD BX,BX
  ADD BX,BX
  MOV DX,OFFSET BUFDIR
  ADD BX,DX
  RET

FS_FNDF:PUSH DX
  MOV AL,byte ptr DS:(CWDS+1)
  OR AL,AL
  JNZ FS_FF1
  CALL FAT_EOF
  MOV DX,OFFSET ROOTSEC
  MOV BX,OFFSET BLKSEC
  CALL COPY4
  MOV AL,byte ptr DS:ROOTLNS
  JMP FS_FF2
FS_FF1: MOV DX,OFFSET CWDBLK
  MOV BX,OFFSET BNEXT
  CALL COPY4
  XOR AL,AL
FS_FF2: MOV byte ptr DS:BLKLEN,AL
  XOR AL,AL
  MOV byte ptr DS:DIRREC,AL
  POP DX
FS_FNDN:PUSH DX
  CALL FS_NEXT
  POP DX
  JNC $+3
  RET
  PUSH BX
  MOV CL,20H
  XOR AL,AL
FS_FNDN1:
  OR AL,[BX]
  INC BX
  DEC CL
  JNZ FS_FNDN1
  POP BX
  OR AL,AL
  STC
  JNZ $+3
  RET
  MOV AL,[BX]
  CMP AL,0E5H
  JZ FS_FNDN
  PUSH DX
  PUSH BX
  CALL STRMASK
  POP BX
  POP DX
  JNZ FS_FNDN
  RET

FS_GETB:MOV DX,OFFSET 20
  ADD BX,DX
  MOV CL,[BX]
  INC BX
  MOV CH,[BX]
  MOV DX,OFFSET 5
  ADD BX,DX
  MOV DL,[BX]
  INC BX
  MOV DH,[BX]
  RET

FS_CHDIR:XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  SUB AL,5CH
  JNZ FS_CD1
  MOV byte ptr DS:(CWDS+1),AL
  INC DX
  XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  OR AL,AL
  JNZ $+3
  RET
FS_CD1: PUSH DX
FS_CD2: XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  OR AL,AL
  JZ FS_CD3
  INC DX
  SUB AL,5CH
  JNZ FS_CD2
  DEC DX
  XCHG BX,DX
  MOV [BX],AL
  XCHG BX,DX
  INC DX
FS_CD3: XCHG BX,DX
  POP DX
  PUSH BX
  PUSH DX
  CALL FS_FNDF
  POP CX
  JC FS_CD4
  PUSH BX
  MOV DX,OFFSET 11
  ADD BX,DX
  MOV AL,[BX]
  POP BX
  ROL AL,1
  ROL AL,1
  ROL AL,1
  ROL AL,1
  CMC
FS_CD4: POP DX
  JNC $+3
  RET
  PUSH DX
  PUSH CX
  CALL FS_GETB
  MOV BX,OFFSET CWDBLK
  MOV [BX],DL
  INC BX
  MOV [BX],DH
  INC BX
  MOV [BX],CL
  INC BX
  MOV [BX],CH
  POP DX
  MOV BX,OFFSET CWDS
  MOV AL,[BX]
FS_CD41:
  INC BX
  MOV CH,AL
  MOV AL,[BX]
  OR AL,AL
  JNZ FS_CD41
  XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  CMP AL,'.'
  JNZ FS_CD5
  INC DX
  XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  CMP AL,'.'
  JNZ FS_CD6
FS_CD42:
  DEC BX
  MOV AL,[BX]
  MOV BYTE PTR [BX],0
  CMP AL,5CH
  JNZ FS_CD42
  MOV byte ptr DS:CWDS,AL
  JMP FS_CD6
FS_CD5: MOV AL,CH
  CMP AL,5CH
  JZ FS_CD51  
  MOV BYTE PTR [BX],5CH
  INC BX
FS_CD51:
  CALL STRCPY
FS_CD6: POP DX
  XCHG BX,DX
  MOV AL,[BX]
  XCHG BX,DX
  OR AL,AL
  JNZ $+3
  RET
  JMP FS_CD1

F_OPEN: MOV BX,OFFSET 0
  MOV word ptr DS:FBLEN,BX
FS_OPEN:CALL FS_FNDF
  JNC $+3
  RET
  CALL FS_GETB
  MOV BX,OFFSET BNEXT
  MOV [BX],DL
  INC BX
  MOV [BX],DH
  INC BX
  MOV [BX],CL
  INC BX
  MOV [BX],CH
  XOR AL,AL
  MOV byte ptr DS:BLKLEN,AL
  RET

F_READ: MOV AL,CH
  OR AL,CL
  JNZ $+3
  RET
  PUSH BX
  MOV BX,word ptr DS:FBLEN
  MOV AL,BH
  OR AL,BL
  JZ F_RD1
  CALL SUBHB
  JNC F_RD3
  POP DX
  PUSH CX
  MOV BX,word ptr DS:FBLEN
  MOV CH,BH
  MOV CL,BL
  POP BX
  CALL SUBHB
  PUSH BX
  MOV BX,word ptr DS:FBPOS
  XCHG BX,DX
  CALL COPY
  POP CX
  PUSH BX
F_RD1:  MOV AL,CH
  CMP AL,2
  JNC F_RD2
  PUSH CX
  MOV BX,OFFSET 200H
  MOV word ptr DS:FBLEN,BX
  MOV BX,OFFSET BUFDIR
  MOV word ptr DS:FBPOS,BX
  CALL FS_READ
  POP CX
  POP BX
  JNC F_READ
  RET
F_RD2:  MOV BX,OFFSET 0
  MOV word ptr DS:FBLEN,BX
  POP BX
  PUSH CX
  CALL FS_READ
  POP CX
  JNC $+3
  RET
  DEC CH
  DEC CH
  JMP F_READ
F_RD3:  MOV word ptr DS:FBLEN,BX
  MOV BX,word ptr DS:FBPOS
  XCHG BX,DX
  POP BX
  CALL COPY
  XCHG BX,DX
  MOV word ptr DS:FBPOS,BX
  XCHG BX,DX
  RET

;#ifdef RWR ;!!!!!!!!!!!!!!!!!!!!!!!!!!!
F_WRITE: MOV AL,CH
  OR AL,CL
  JNZ $+3
  RET
  PUSH BX
  MOV BX,word ptr DS:FBLEN
  MOV AL,BH
  OR AL,BL
  JZ F_WR1
  POP BX
  RET
F_WR1:  MOV AL,CH
  CMP AL,2
  JNC F_WR2
  MOV BX,OFFSET 200H
  MOV word ptr DS:FBLEN,BX
  POP BX
  PUSH CX
  CALL FS_WRITE
  POP CX
  JNC F_WRITE
  RET
F_WR2:  MOV BX,OFFSET 0
  MOV word ptr DS:FBLEN,BX
  POP BX
  PUSH CX
  CALL FS_WRITE
  POP CX
  JNC $+3
  RET
  DEC CH
  DEC CH
  JMP F_WRITE
;#endif ;!!!!!!!!!!!!!!!!!!!!!!!!!!!

TEXT   ENDS

  END
